\documentclass[../Documentation_Bern_RTOS_PAI]{subfiles}

\begin{document}
\begin{tikzpicture}[bern_rtos_style]
    \node[level] (irq) {Interrupt};
    \node[level, below = \tasklevelsep of irq.south west, anchor=north west] (sched) {Scheduler};
    \node[level, below = \tasklevelsep of sched.south west, anchor=north west] (prio_2) {Priority 2};
    \node[level, below = \taskpriosep of prio_2.south west, anchor=north west] (prio_1) {Priority 1};
    \node[level, below = \taskpriosep of prio_1.south west, anchor=north west] (prio_0) {Priority 0};

    \node[task, right = \taskfirstsep of prio_1, minimum width = 2.5*\taskunit] (t_1) {T1};
    \node[task] (irq_0) at (irq -| t_1.east) {};
    \node[task] (sched_0) at (sched -| irq_0.east) {};
    \node[task, minimum width = 3.5*\taskunit] at (prio_2 -| sched_0.east) (t_2) {T2};
    \node[task] (sched_1) at (sched -| t_2.east) {};
    \node[task, minimum width = 1.5*\taskunit] at (prio_1 -| sched_1.east) (t_3) {T1};
    \node[task] (sched_2) at (sched -| t_3.east) {};
    \node[task, minimum width = 2*\taskunit] at (prio_0 -| sched_2.east) (t_4) {Idle};

    \node[circled, left = \tasknotedist of irq_0] {1};
    \node[circled, below = \tasknotedist of t_2.south west] {2};
    \node[circled, left = \tasknotedist of sched_1] {3};

    \path[->] 
        (t_1.north east) edge[interrupt] node {interrupt} (irq_0.south west)
        (irq_0.south east) edge (sched_0.north west)
        (sched_0.south east) edge (t_2.north west)
        (t_2.north east) edge node {yield} (sched_1.south west)
        (sched_1.south east) edge (t_3.north west)
        (t_3.north east) edge node {yield} (sched_2.south west)
        (sched_2.south east) edge (t_4.north west);

    \end{tikzpicture}
\end{document}